// This is a roxen module.
// $Id: flash2.pike,v 0.01 1998/02/16 10:40:18 Frumph Exp $
// <flash2> created by 
// Philip M. Hofer (Frumph) 1998, Feb
// frumph@staticunderground.com
// 
// The purpose of this module is to create a tag that includes parameters that are
// quite often missed when doing an embed statement by itself by html designers.
// Standard pluginspath and Mime type are quite forgotten on occasions.
//
// Future version will include the javascript code for 'smart' downloading of 
// the plugin
//
// -----------------------------------------------------------------------
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// -----------------------------------------------------------------------


constant cvs_version = "$Id: flash2.pike,v 0.01 1998/02/16 10:40:18 Frumph Exp $";
constant thread_safe=1;

#include <module.h>
inherit "module";

void create() {
  defvar("pluginspath", "http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash", 
	"direct URL - Path for the Plugins page", TYPE_STRING,
         "the URL of the plugins themselves" );
  defvar("typepath", "application/x-shockwave-flash", "the MIME type to include in the tag", TYPE_STRING,
         "the mime type to include in the tag" );

 }

mixed *register_module()
{
  return ({ 
    MODULE_PARSER,
    "Flash2 Tag",
      ("Flash2 Tag<br>"
       "<br><br>"
       "Includes often forgotten pluginspath and mime-type information in the embed<br>"
       "of the Macromedia Flash2 (Shockwave) .swf<br><br>"
       "by Philip M. Hofer (Frumph)  frumph@staticunderground.com"
       "<pre>"
       "&lt;flash2&gt;\n\n"
       "   Edits a tag and includes embed information\n" 
       "             for .swf macromedia flash files.\n\n"  
       "   src=         - REQUIRED; the src file .swf\n"
       "   loop=        - loop how many times, TRUE for continueous\n"
       "   height=      - height of flash image\n"
       "   width=       - width of image\n"
       "   quality=     - best, good, optimal\n"
       "   bgcolor=     - standard colors\n\n"
       "</pre>"   
       ), ({}), 1,
    });
}

string tag_flash2( string tag, mapping args, object id ) {
        string s;

        switch (tag) {
        case "flash2":
        s = "<embed src=\""+(args->src)+"\" type=\""+query("typepath")+"\"\n pluginspage=\""+query("pluginspath")+"\"\n"
                 + (args->width?" width="+args->width:"")
                 + (args->height?" height="+args->height:"")
                 + (args->bgcolor?" bgcolor="+args->bgcolor:"")
                 + (args->quality?" quality="+args->quality:"")
		 + (args->loop?" loop="+args->loop:"")
                 + ">"; 
	        break;
        }
	return s;
}

mapping query_tag_callers()
{
  return ([ "flash2" : tag_flash2 ]);
}
